<template>
    <div ref="mainCont" class="d-flex justify-content-center">
        <input 
            ref="costil" 
            type='text' 
            style="opacity:0;cursor:pointer;position:absolute;"
            readonly
        >
        <div ref="rowCont" class="vid-row">
            <div
                class="d-flex align-items-center"
                ref="mainContVideo"
                :style="`margin-top:20px;margin-bottom:20px;position: relative;cursor:auto;max-width:${control.width}px;max-height:${Math.floor(control.width/1.77)}px;`"
                @mouseenter="isControl(true)"
                @mouseleave="isControl(false)"
                @contextmenu="onContextmenu"
                >
                
                <div v-if="!error && !ready"
                    class="on-center"
                >
                    <div class="spinner-border text-dark" role="status">
                        <span class="sr-only">Loading...</span>
                    </div>
                </div>
                <div v-if="!error && !ready"
                    class="fon_loading"
                >
                </div>
                <div v-if="!error && !select_video.poster && select_video.current_time<=0 && !ready"
                    class="fon_loading"
                >
                </div>
                
        
                <div ref="btn_play" v-if="!control.play && !error && ready"
                    :style="`z-index: 100;position: absolute;cursor:pointer;left:${main_ico_pos.left}px;top:${main_ico_pos.top}px;`"
                    @click="onPlay"
                >
                    <svg 
                        xmlns="http://www.w3.org/2000/svg" 
                        :width="size" 
                        :height="size"
                        viewBox="0 0 60 60"
                        style="cursor:pointer;"
                    >
                        <radialGradient id="SVGID_1_" cx="30" cy="30" r="29.3037" gradientTransform="matrix(1.0238 0 0 1.0238 -0.7132 -0.7132)" gradientUnits="userSpaceOnUse">
                            <stop  offset="0.3" style="stop-color:#000000;stop-opacity:0"/>
                            <stop  offset="0.8873" style="stop-color:#000000;stop-opacity:0.6512"/>
                            <stop  offset="1" style="stop-color:#000000;stop-opacity:0.95"/>
                        </radialGradient>
                        <circle fill="url(#SVGID_1_)" cx="30" cy="30" r="30"/>
                        <path :fill="`${main_color}`" d="M48.091,28.407l-29.381-14.24v31.666l29.609-14.24C51.084,30.268,51.114,29.793,48.091,28.407z"/>
                    </svg>
                    
                </div>
                    <video 
                        ref="video" 
                        :width="control.width"
                        :height="control.height"
                        style="cursor:auto;"
                        @volumechange="volumeChange"
                        @click="onPlay"
                    >
                        
                    </video>
                <ControlPanel
                    :color="main_color"
                    :is_control="is_control"
                    :error="error"
                    :control="control"
                    :select_video="select_video" 
                    @onPlay="onPlay" 
                    @changeTime="changeTime"
                    @onSound="onSound"
                    @onChangeSound="onChangeSound"
                    @toggleSideList="toggleSideList"
                    @onChangeSpeed="onChangeSpeed"
                    @onToggleFullscreen="toggleFullscreen"/>
                
                <BtnNextVideo 
                    :next_video="next_video"
                    
                    @onNext="onNext"
                    @onClose="closeNextVideo"
                />
                <PlayerContextMenu 
                    :context_menu="context_menu"
                    :hot_key_menu="hot_key_menu"
                    @openSubMenu="contextMenuClickOn"
                    @openSubMenuPiP="openPiP"
                    @closeSubMenu="contextMenuClickOff"
                />
                <div 
                    class="on-center"
                    style="top:0;left:0;"
                    v-if="error"
                >
                    <ErrorSVG 
                        :color="t_color"
                        :width="control.width"
                        :height="control.height"
                    />
                </div>
            </div>
                
            <PlaySheet 
                :arr_videos="arr_videos"
                :reactiv_arr_videos="reactiv_arr_videos"
                :control="control"
                :height="list_height"
                :t_main_color="list_color"
                :t_select_color="list_select_color"
                :t_text_color="list_text_color"
                :_select_video="next_video_idx"
                @onAutoPlay="onAutoPlay"
                @changeVideo ="changeVideo"
                @initPlayer="initPlayer"/>
        </div>
    </div>
</template>

<script>
import ControlPanel from './ControlPanel.vue';
import PlaySheet from './PlaySheet.vue';
import PlayerContextMenu from './PlayerContextMenu.vue';
import BtnNextVideo from './BtnNextVideo.vue';
import ErrorSVG from './ErrorSVG';
import VolumServic from '../services/volumServic';
import videoInfo from '../services/videoInfo';
import KeyBoardListener from '../services/keyBoardEvents';
import CalcSizer from '../services/calcSizer';

export default {
    name: 'VideoPlayer',
    components: {
        ControlPanel,
        PlaySheet,
        BtnNextVideo,
        PlayerContextMenu,
        ErrorSVG
    },
    props: {
        arr_videos:Array,
        color:String,
        width:Number,
        list_height:Number,
        list_color:String,
        list_select_color:String,
        list_text_color:String
    },
    data: () => ({
        d_font_size:200,
        main_ico_pos:{left:0,top:0},
        size:200,
        _reason:'',
        auto_play:false,
        next_video_idx:0,
        t_color:'rgb(252, 231, 41)',
        main_color:null,
        reactiv_arr_videos:[],
        select_video:{},
        index_next_video:0,
        next_video:null,
        close_next_video:false,
        is_control: false,
        ready: false,
        timer:null,
        context_menu:false,
        hot_key_menu:false,
        context_pause:false,
        volumServic:null,
        poster:false,
        control:{
            default_width:800,
            //default_height:450,
            width:0,
            list_orientation:'',
            height:0,
            full_screen:false,
            play: false,
            panel: false,
            befor_mute:1,
            volum:1,
            speeds:[
                0.5,
                0.75,
                1,
                1.2,
                1.4,
                1.6,
                1.8,
                2
            ]
        },
        error:false,
        keyBoardListener:null
    }),
    watch:{
        'width':'setDefaultWidth',
        'control.width':'calcHeight',
        'color':'setColor'
    },
    mounted(){
        if(this.color){
            this.main_color = this.color;
        }else{
            this.main_color = this.t_color;
        }
        this.volumServic = new VolumServic(this.$refs.video,this.control);

        this.keyBoardListener = new KeyBoardListener({
            el:this.$refs.costil,
            context:this.volumServic
        });
        this.keyBoardListener.addEvent('Space',this.onPlay);
        this.keyBoardListener.addEvent('NumpadAdd',this.volumServic.onUpSound);
        this.keyBoardListener.addEvent('NumpadSubtract',this.volumServic.onDownSound);
        this.keyBoardListener.addEvent('ArrowLeft',this.onBackRemote);
        this.keyBoardListener.addEvent('ArrowRight',this.onNextRemote);

        this.$refs.video.addEventListener('timeupdate', this.onTimeUpdate);
        this.$refs.video.addEventListener('waiting', this.onWaiting);
        this.$refs.video.addEventListener('loadstart', this.onLoadStart);
        this.$refs.video.addEventListener('ended', this.onEnded);
        
        this.$refs.mainContVideo.addEventListener('fullscreenchange', this.onFullscreenchange);
        this.$refs.mainContVideo.addEventListener('mousemove', this.onMousemove);
        
        this.$refs.mainCont.addEventListener('mouseup', (e)=>{
            this.$refs.costil.focus({preventScroll:true});
        });
        //this.$refs.mainContVideo.addEventListener('mousemove', this.onMousemove);
        const player_settings = videoInfo.getPlayerSettings();

        this.onChangeSpeed(player_settings.speed);
        this.volumServic.onChangeSound(player_settings.volum);
        this.setSideList(player_settings.list_orientation);
        window.addEventListener('resize', this.onResize);
    },
    beforeDestroy(){
        clearTimeout(this.timer);
    },
    methods:{
        onNextRemote(){
            let to = this.$refs.video.currentTime + 5;
            if(to>this.select_video.time){
                to = this.select_video.time;
            }
            this.setTimer();
            this.changeTime(to);
        },
        onBackRemote(){
            let to = this.$refs.video.currentTime - 5;
            if(to<0){
                to = 0
            }
            this.setTimer();
            this.changeTime(to);
        },
        setSideList(side){
            if(side==='row'){
                this.$refs.rowCont.classList.add("vid-row");
                this.control.list_orientation = 'row';
                videoInfo.setListOrientation('row');
            }else{
                this.$refs.rowCont.classList.remove("vid-row");
                this.control.list_orientation = 'col';
                videoInfo.setListOrientation('col');
            }
            this.onResize();
        },

        toggleSideList(){
            if(this.control.list_orientation==='row'){
                this.setSideList('col');
            }else{
                this.setSideList('row');
            }
        },

        setColor(){
            this.main_color = this.color;
        },

        onAutoPlay(val){
            this.auto_play = val;
        },

        onNext(){
            this._reason = 'next';
            this.next_video_idx = this.index_next_video;
            //console.log('next_video_idx = ', this.next_video_idx );
        },

        setDefaultWidth(width){
            if(this.control.full_screen){
                return;
            }
            this.control.default_width = width;
            //console.log('default_width = ', this.control.default_width);
        },

        setWidth(width){
            //console.log('поменял width = ', width);
            if(width<420){
                width = screen.width;
                if(this.control.list_orientation==='row'){
                    this.control.width = width;
                    this.setSideList('col');
                    return;
                }
            }
            this.control.width = width;
            this.setDefaultWidth(width);
            const size = CalcSizer.calcSizeico(this).size;
            this.size = size+'px'; 
            this.main_ico_pos.left = width/2 - size/2;
        },

        calcHeight(){
            //console.log('назначил Высоту!!!');
            const width = this.control.width;
            this.control.height = Math.floor(width/1.77);
            this.main_ico_pos.top = this.control.height/2-parseInt(this.size)/2;
        },

        onResize(){
            if(this.control.full_screen){
                this.setWidth(screen.width);
                return;
            }
            //console.log('поймал ресайз!!');
            this.setWidth(CalcSizer.calcWidth(this));
        },

        getWidth(){
            let width = CalcSizer.calcWidth(this);
            this.setWidth(width);
            this.setDefaultWidth(width);
        },
        openPiP(){
            if (!document.pictureInPictureEnabled) {
                console.log('не поддерживаеться pictureInPictureEnabled');
                return;
            }

            this.$refs.video.requestPictureInPicture()
                .then(() => {
                    this.context_menu = false;
                    this.hot_key_mune = false;
                    this.$refs.video.addEventListener('leavepictureinpicture', () => {
                        this.control.play = false;
                        this.contextMenuClickOff();
                    });
                })
                .catch(() => { /**/ });
        },
        isControl(val){
            if(this.reactiv_arr_videos.length>=1){
                this.is_control = val;
            }
        },
        contextMenuClickOn(){
            this.setTimer();
            this.context_menu = false;
            this.hot_key_menu = true;
            
        },
        contextMenuClickOff(){
            this.context_menu = false;
            this.hot_key_menu = false;
            if(!this.control.play && this.context_pause){
                this.context_pause = false;
                this.onPlay();
            }
        },
        onContextmenu(e){
            e.preventDefault();
            if(this.context_pause || this.hot_key_menu){
                return;
            }
            this.setTimer();

            if(this.control.play){
                this.context_pause = true;
                this.onPlay();
            }
            this.context_menu = true;
        },
        setTimer(){
            if(this.timer){
                clearTimeout(this.timer);
            }
            this.timer = setTimeout(this.timeToHide,2200);
        },

        timeToHide(){
            this.is_control = false;
            this.context_menu = false;
            this.$refs.mainContVideo.style.cursor = 'none';
            this.$refs.video.style.cursor = 'none';
        },

        onMousemove(){
            this.setTimer();
            this.$refs.mainContVideo.style.cursor = 'auto';
            this.$refs.video.style.cursor = 'auto';
            if(!this.is_control && this.reactiv_arr_videos.length>=1){
                this.is_control = true;
            }
        },

        onMainContVideo(e){
            if(e.which == 3){
                e.preventDefault();
            }
        },
        onLoadStart(){
            this.ready = false;
        },

        onWaiting(){
            this.ready = false;
        },
        onError(e){
            try{
                e.target.error.code;
                this.error = true;
                //console.log("Error " + e.target.error.code + "; details: " + e.target.error.message);
            }
            catch(error){
                console.log('error = ','неизвестная ошибка');
            }
        },
        onCanplay(){
            //console.log('готов проигрывать!!');
            if(this.select_video.poster){
                this.$refs.video.poster = this.select_video.poster;
            }
            this.onChangeSpeed(videoInfo.getPlayerSpeed());
            this.ready = true;
            this.error = false;
            if(this._reason==='next'){
                this._reason='';
                this.onPlay();
            }
        },
        onEnded(){
            if(this.auto_play && this.control.play){
                console.log('onEnded');
                //this._reason = 'next';
                this.onNext();
            }
            this.control.play = false;
        },
        initPlayer({new_arr,index}){
            this.reactiv_arr_videos = new_arr;
            if(this.reactiv_arr_videos.length<=0){
                return;
            }
            this.select_video = this.reactiv_arr_videos[index];
            
            this.index_next_video = index+1;
        
            this.$refs.video.addEventListener('canplay', this.onCanplay);
            this.$refs.video.addEventListener('error', this.onError);
            this.$refs.video.src = this.select_video.src;

            this.changeTime(this.select_video.from);
            this.onTimeUpdate();
        },

        closeNextVideo(){
            this.close_next_video = true;
            this.showNextVideo(false);
        },

        showNextVideo(val){
            if(!val || this.close_next_video){
                this.next_video = null;
                return;
            }
            if(this.next_video && this.index_next_video>this.reactiv_arr_videos){
                this.next_video = null;
                return;
            }
            this.next_video = this.reactiv_arr_videos[this.index_next_video];
        },

        changeVideo(index){
            this.next_video_idx = -1;
            if(!index && index!==0){
                index = this.index_next_video;
            }
            this.control.play = false;
            this.select_video = this.reactiv_arr_videos[index];
            this.$refs.video.src = this.select_video.src;
            
            this.changeTime(this.select_video.from);
            this.onTimeUpdate();
            this.index_next_video = index+1;
            this.close_next_video = false;
        },
        changeTime(time){
           this.$refs.video.currentTime = time;
        },
        onSound(){
            this.volumServic.onSound();
        },
        onChangeSound(vol){
            this.volumServic.onChangeSound(vol);
        },
        onChangeSpeed(speed){
            videoInfo.setSpeed(speed);
            this.$refs.video.playbackRate = speed;
            this.select_video.playback_rate = speed;
        },
        volumeChange(){
            this.volumServic.volumeChange();
        },
        onTimeUpdate(){
            this.select_video.percent = this.$refs.video.currentTime* 100/ this.select_video.time;
            if(this.select_video.percent>=94){
                this.showNextVideo(true);
            }else{
                this.showNextVideo(false);
            }
            this.select_video.current_time = this.$refs.video.currentTime;
            this.select_video.from = this.select_video.current_time;
            videoInfo.setVideoTime(this.select_video.id, this.$refs.video.currentTime);
        },
        onPlay(){
            if(this.reactiv_arr_videos.length<=0){
                return;
            }
            if(this.error || this.hot_key_menu){
                return;
            }
            this.context_menu = false;
            if(!this.control.play){

                this.control.play = true;
                this.$refs.video.play();
                this.setTimer();
            }else{
                this.control.play = false;
                this.$refs.video.pause();
            }
        },
        onFullscreenchange(){
            if(!document.fullscreenElement){
                this.control.full_screen = false;
                console.log('эпытаюсь назначить = ', this.control.default_width);
                this.setWidth(this.control.default_width);
                //this.control.width = this.control.default_width;
                //this.control.height = this.control.default_height;
            }
        },
        toggleFullscreen() {
            let elem = this.$refs.mainContVideo;

            if (!document.fullscreenElement) {
                elem.requestFullscreen()
                .then(()=>{
                    //this.control.width = screen.width;
                    //this.control.height = screen.height;
                    this.control.full_screen = true;
                })
                .catch(err => {
                    alert(`Error attempting to enable full-screen mode: ${err.message} (${err.name})`);
                });
            } else {
                this.setWidth(this.control.default_width);
                document.exitFullscreen();
            }
        }
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
    .cont-fon{
        position: absolute;
        z-index:99;
        /* width: 0;
        height: 0; */
        /* border-radius: 50%;
        -moz-border-radius: 50%;
        -webkit-border-radius: 50%;
        -khtml-border-radius: 50%;
        background-image: radial-gradient(circle, #000000, #00000080,#ffffff00); */
    }
    .fon{
        width:120px;
        height:120px;
        margin-top:-52%;
        margin-left:-56%;
        /* width: 100%;
        height: 100%; */
        border-radius: 50%;
        -moz-border-radius: 50%;
        -webkit-border-radius: 50%;
        -khtml-border-radius: 50%;
        /* background: #4CAF50; */
        background-image: radial-gradient(circle, #000000, #00000050,#ffffff00);
        /* background: linear-gradient(to top, #000000, #00000080,#ffffff00); */
    }
    .fon_loading{
        width: 100%;
        height: 100%;
        z-index: 99;
        background:black;
        position: absolute;
        opacity: 0.5;
    }
    .on-center{
        left:50%;
        top:50%;
        z-index: 100;
        position: absolute;
    }
    .div_ico_btn{
        position: absolute;
        cursor:pointer;
        margin-left:-50%;
        margin-top:-50%;
        /* color: rgb(252, 231, 41); */
    }
    .vid-row{
        display: flex;
        width:100%;
        flex-wrap: wrap;
        justify-content: center!important;
    }
    .vid-col{
        flex-basis: 0;
        position: relative;
        width: 100%;
        /* padding-right: 15px; */
        /* padding-left: 15px; */
    }
</style>
